﻿/* Mouse Trailer */
/* Developed by Carlos Yanez */

package 
{
	import flash.display.Sprite;
	import flash.ui.Mouse;
	import flash.events.MouseEvent;
	import flash.events.Event;

	public class MouseTrailer extends Sprite
	{
		/* Light ball object */
		
		var lightBall:LightBall;
		
		/* Constructor */

		public function MouseTrailer():void
		{
			Mouse.hide();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, startTrailer);
		}

		private function startTrailer(e:MouseEvent):void
		{
			/* Create a new LightBall object */

			lightBall = new LightBall();

			/* Position */

			lightBall.x = mouseX + Math.random() * lightBall.width;
			lightBall.y = mouseY - Math.random() * lightBall.height;

			/* Add to Stage */

			addChild(lightBall);

			/* Add Listener to Animate function */

			lightBall.addEventListener(Event.ENTER_FRAME, animate);
		}

		/* Animate function */

		private function animate(e:Event):void
		{
			/* Alpha */

			e.target.alpha -= 0.05;

			/* If lightBall is no longer visible, remove it */

			if (e.target.alpha <= 0)
			{
				e.target.removeEventListener(Event.ENTER_FRAME, animate);

				removeChild(e.target as Sprite);
			}

			/* Scale */

			e.target.scaleX -= 0.1;
			e.target.scaleY -= 0.1;

			/* Y Position */

			e.target.y += 3;
		}
	}
}